//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Main.h"
#include "Set.h"
#include <iostream.h>
//---------------------------------------------------------------------------
#pragma link "TCOMM_32"
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  CommPort1->Open();
  CommPort1->SetMCDTR(True);
  UpdateLights();
  StatusBar1->Panels->Items[1]->Text="Port is opened";
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
String Buf =
       Memo1->Lines->Strings[(Memo1->Lines->Count-1)]+'\r';

// Application->ProcessMessages();
CommPort1->SetMCRTS(True);
LiteTxD->Brush->Color=clRed;
LiteTxD->Refresh();
CommPort1->WriteCommString(Buf);
Application->ProcessMessages();
LiteTxD->Brush->Color=clGreen;
LiteTxD->Refresh();

CommPort1->SetMCRTS(False);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::CommPort1Receive(apBuffer bufptr, int size)

{
   LiteRxD->Brush->Color=clRed;
   LiteRxD->Refresh();
   // alocat a buffer + 1 or you get pointer errors
   char* szMyBuf = new char[size+1];

   // Required to "Clean Up" strings coming from the port buffer
   StrLCopy( szMyBuf, *bufptr, size );

//   Memo2->Lines->Add(*bufptr);

// The Lines above & below give a messy display because they
// add carriage returns and line feeds

//   Memo2->Lines->Add(szMyBuf);

   Memo2->Text = Memo2->Text + szMyBuf;

   // this line gives a messy display, because
   // the buffer of BytesToReceive size is not always full
   // or it has old data left in it, so the display is
   // very confusing         DWR 98.10.23

   //   Memo2->Text=Memo2->Text+*bufptr;

   Memo2->Refresh();
   LiteRxD->Brush->Color=clGreen;
   LiteRxD->Refresh();
  //   Application->ProcessMessages();
  delete [] szMyBuf;
 }

//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
 CommPort1->CloseComm(CommPort1->WComID);
 UpdateLights();
 StatusBar1->Panels->Items[1]->Text="Port is closed";
 }

//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
 frmSettings->ShowModal();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::UpdateLights()
{
 if (CommPort1->MCTSOn) LiteCTS->Brush->Color=clRed; else LiteCTS->Brush->Color=clGreen;
 if (CommPort1->MRingOn) LiteRing->Brush->Color=clRed; else LiteRing->Brush->Color=clGreen;
 if (CommPort1->MRLSDOn) LiteRLSD->Brush->Color=clRed; else LiteRLSD->Brush->Color=clGreen;
 if (CommPort1->MDSROn)  LiteDSR->Brush->Color=clRed; else LiteDSR->Brush->Color=clGreen;
 }//Procedure
//---------------------------------------------------------------------------
